_asm_exec_ram       = $d748
_clrLCD             = $4a7e
_puts               = $4A37
_putmap             = $4A27
_putc               = $4A2B
_curRow             = $0C00F
_curCol             = $0C010
_pause              = $4d43
_getkey             = $55AA
_OP1                = $c089
UNPACK_HL           = $4044
value               = $f200
key_pressed         = $f201

.org _asm_exec_ram
    
    nop
    jr ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "CharViewer v1.0 by T. Chevalier",0

ProgStart:

    call _clrLCD

    ld bc, $0000
    ld (_curRow), bc
    ld a, 223
    call _putmap
    ld b, 20
    ld (_curRow), bc
    ld a, 223
    call _putmap
    ld bc, $0501
    ld (_curRow), bc
    ld a, 6
    call _putmap
    ld c, 7
    ld (_curRow), bc
    ld a, 7
    call _putmap
    ld bc, $0f01
    ld (_curRow), bc
    ld a, 6
    call _putmap
    ld c, 7
    ld (_curRow), bc
    ld a, 7
    call _putmap


    xor a
    ld (value), a
    call draw_7_lines
        
new_scrolling:
    ld de, 0
    ld bc, text_piece-text-19
    ld b, c
scroll_loop:
    push bc
    ld bc, (256*1)+0
    ld (_curRow), bc
    ld hl, text
    add hl, de
    push de
    ld de, text_piece
    ld bc, 19
    ldir
    xor a
    ld (de), a
    ld hl, text_piece
    call _puts
    pop de
    inc de
    xor a
    ld (key_pressed), a
    ld b, 10
halt_loop:
    halt
    
    ld a, (key_pressed)
    cp 0
    jr nz, not_this_time
    
    push de
    
    ld a,%01111110
    out (1),a
    nop
    nop
    in a,(1)
    bit 3,a 
    call z, up_key

    ld a,%01111110
    out (1),a
    nop
    nop
    in a,(1)
    bit 0,a
    call z, down_key
    
    ld a,%00111111
    out (1),a
    nop
    nop
    in a,(1)
    bit 6,a
    jr z, exit
    
    pop de

not_this_time:
        
    djnz halt_loop
    
    pop bc
    djnz scroll_loop
    jr new_scrolling
    
up_key:
    ld a, 1
    ld (key_pressed), a
    ld a, (value)
    dec a
    ld (value), a
    jr draw_7_lines
down_key:
    ld a, 1
    ld (key_pressed), a
    ld a, (value)
    inc a
    ld (value), a
    jr draw_7_lines   

exit:
    pop hl
    pop hl
    call _clrLCD
    ret

draw_7_lines:
    ld c, 1
next_line:
    ld b, 7
    push af
    push bc
    push af
    ld (_curRow), bc
    call _putmap
    ld b, 9
    ld (_curRow), bc
    ld hl, small_blank
    push bc
    call _puts
    pop bc
    ld b, 11
    ld (_curRow), bc
    ld h, 0
    pop af
    ld l, a
    call DisplayHL
    pop bc
    pop af
    inc a
    inc c
    ld d, a
    ld a, c
    cp 8
    ld a, d
    jr nz, next_line
    ret


;====================================================================
; DisplayHL:  (idea from SCaBBy/Mardell)    [Assembly Coder's Zenith]
;  Display HL as a 5-digit decimal number with no leading zeros
;  out: AF, HL, BC, DE destroyed
;====================================================================
DisplayHL:
 ld c,'0'           ; save ascii value for zero
 ld de,_OP1+5           ; point to end of the buffer
 xor a              ; zero terminate string
 ld (de),a          ; set last byte to zero
DisplayHLl:
 call UNPACK_HL         ; next digit
 dec de             ; next position
 add a,c            ; convert to ascii
 ld (de),a          ; save digit
 ld a,h             ; load upper byte
 or l               ; check with lower byte for zero
 jr nz,DisplayHLl       ; loop
 ex de,hl           ; point to buffer
 call _puts            ; print number
 ret                ; we're done

small_blank: .db "=    ", 0
text: .db "                     "
your_text: .db "...Welcome to CharViewer ! This programs allows you to see the ascii equivalent for each character of the TI-86 ! Use up and down arrows to see other characters and exit to quit..." 
end_of_text: .db "                     ", 0
text_piece : 

.end
